﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// AES 헬퍼
    /// </summary>
    public class AESHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 암호화 하기 - Encrypt(plainText, password)

        /// <summary>
        /// 암호화 하기
        /// </summary>
        /// <param name="plainText">평문 텍스트</param>
        /// <param name="password">패스워드</param>
        /// <returns>암호화 텍스트</returns>
        public static string Encrypt(string plainText, string password)
        {
            RijndaelManaged rijndaelManaged = new RijndaelManaged();

            byte[] saltArray       = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] plaintTextArray = Encoding.Unicode.GetBytes(plainText);

            Rfc2898DeriveBytes rfc2898DeriveBytes = new Rfc2898DeriveBytes(password, saltArray, 100);

            ICryptoTransform cryptoTransform = rijndaelManaged.CreateEncryptor(rfc2898DeriveBytes.GetBytes(32), rfc2898DeriveBytes.GetBytes(16));

            MemoryStream memoryStream = new MemoryStream();
            CryptoStream cryptoStream = new CryptoStream(memoryStream, cryptoTransform, CryptoStreamMode.Write);

            cryptoStream.Write(plaintTextArray, 0, plaintTextArray.Length);

            cryptoStream.FlushFinalBlock();
 
            byte[] cipherTextArray = memoryStream.ToArray();

            string cipherText = Convert.ToBase64String(cipherTextArray);
 
            memoryStream.Close();
            cryptoStream.Close();

            return cipherText;
        }

        #endregion
        #region 복호화 하기 - Decrypt(cipherText, password)

        /// <summary>
        /// 복호화 하기
        /// </summary>
        /// <param name="cipherText">암호화 텍스트</param>
        /// <param name="password">패스워드</param>
        /// <returns>평문 텍스트</returns>
        public static string Decrypt(string cipherText, string password)
        {
            RijndaelManaged rijndaelManaged = new RijndaelManaged();

            byte[] saltArray       = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] cipherTextArray = Convert.FromBase64String(cipherText);
            byte[] plainTextArray  = new byte[cipherTextArray.Length];

            Rfc2898DeriveBytes rfc2898DeriveBytes = new Rfc2898DeriveBytes(password, saltArray, 100);

            ICryptoTransform cryptoTransform = rijndaelManaged.CreateDecryptor(rfc2898DeriveBytes.GetBytes(32), rfc2898DeriveBytes.GetBytes(16));

            MemoryStream memoryStream = new MemoryStream(cipherTextArray);
            CryptoStream cryptoStream = new CryptoStream(memoryStream, cryptoTransform, CryptoStreamMode.Read);

            int plainTextCount = cryptoStream.Read(plainTextArray, 0, plainTextArray.Length);

            string plainText = Encoding.Unicode.GetString(plainTextArray, 0, plainTextCount);

            memoryStream.Close();
            cryptoStream.Close();

            return plainText;
        }

        #endregion
    }
}