﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.processButton.Click += processButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 암복호화 버튼 클릭시 처리하기 - processButton_Click(sender, e)

        /// <summary>
        /// 암복호화 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void processButton_Click(object sender, EventArgs e)
        {
            string cipherText = AESHelper.Encrypt(this.plainTextTextBox.Text, this.passwordTextBox.Text);

            this.cipherTextTextBox.Text = cipherText;

            string plainText = AESHelper.Decrypt(cipherText, this.passwordTextBox.Text);

            this.resultTextTextBox.Text = plainText;
        }

        #endregion
    }
}